import 'package:flutter/material.dart';
import 'package:marianum_mobile/view/pages/more/highEduGraduationCalculator/models/subject.dart';
import 'package:marianum_mobile/view/pages/more/highEduGraduationCalculator/selectLkView.dart';

class HighEduGraduationCalculator extends StatefulWidget {
  const HighEduGraduationCalculator({super.key});

  @override
  State<HighEduGraduationCalculator> createState() => _HighEduGraduationCalculatorState();
}

class _HighEduGraduationCalculatorState extends State<HighEduGraduationCalculator> {
  SubjectCollection allSubjects = SubjectCollection([
    Subject(displayName: "Mathe", lkApplicable: true),
    Subject(displayName: "Physik", lkApplicable: true),
    Subject(displayName: "Chemie", lkApplicable: true),
    Subject(displayName: "Biologie", lkApplicable: true),
    Subject(displayName: "Englisch", lkApplicable: true),
    Subject(displayName: "Latein", lkApplicable: true),
  ]);

  SubjectCollection? lkSubjects;

  int currentStep = 0;
  List<Step> steps() => [
    Step(title: const Text("Willkommen"), content: Text("test")),
    Step(title: const Text("Leistungskurse wählen"), content: lkSubjectsStep()),
    const Step(title: Text("Grundkurse wählen"), content: Text("Test")),
    const Step(title: Text("Prüfungsfächer wählen"), content: Text("Test")),
    const Step(title: Text("Ergebnis auswerten"), content: Text("Test")),
  ];

  Widget lkSubjectsStep() {
    return Column(
      children: [
        Text(lkSubjects?.subjects.where((e) => e.isLk()).map((e) => e.displayName).join(", ")  ?? "Keine Auswahl"),
        TextButton(
          onPressed: () {
            showDialog(context: context, builder: (context) => SelectLkView(all: allSubjects, update: () => setState(() => { })));
          },
          child: const Text("Ändern"),
        ),
      ],
    );
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: const Text("Abitur Notenrechner"),
      ),
      body: Stepper(
        type: StepperType.vertical,
        steps: steps(),
        currentStep: currentStep,
        onStepContinue: () {
          setState(() {
            currentStep++;
          });
        },
        controlsBuilder: (context, details) {
          return Row(
            children: [
              TextButton(
              onPressed: () => details.onStepContinue,
                child: const Text("Weiter"),
              )
            ],
          );
        },
      )
    );
  }
}
