import 'package:flutter/material.dart';
import 'package:marianum_mobile/view/pages/more/highEduGraduationCalculator/models/subject.dart';
import 'package:marianum_mobile/widget/centeredLeading.dart';

class SelectLkView extends StatefulWidget {
  final SubjectCollection all;
  final void Function() update;
  const SelectLkView({required this.all, required this.update, super.key});

  @override
  State<SelectLkView> createState() => _SelectLkViewState();
}

class _SelectLkViewState extends State<SelectLkView> {
  @override
  Widget build(BuildContext context) {
    return AlertDialog(
      title: const Text("Leistungskurse"),
      content: Column(
        mainAxisSize: MainAxisSize.min,
        children: widget.all.subjects.map((e) {
          return ListTile(
            leading: const CenteredLeading(Icon(Icons.subject_outlined)),
            title: Text(e.displayName),
            trailing: Checkbox(
              value: e.isLk(),
              onChanged: e.isLk() || e.canLk(widget.all.subjects) ? (value) {
                setState(() {
                  e.unsafeLkToggle = value!;
                });
              } : null,
            ),
          );
        }).toList(),
      ),
      actions: [
        TextButton(
          onPressed: () {
            widget.update();
            Navigator.of(context).pop();
          },
          child: const Text("Fertig"),
        )
      ],
    );
  }
}
